class trigger_barrier : ScriptBaseEntity
{
	
	int tower_type = 0;				// 0=free, 1=turret, 2=blue, 3=green, 4=yellow, 5=red
	int tower_ID = 0;
	
	int cooldown = 0;
	int cooldown_blue = 0;
	int cooldown_green = 0;
	int cooldown_yellow = 60;
	int cooldown_red = 120;
	
	int renderamt_on = 200;
	int renderamt_off = 50;
	
	int laserdamage_red_on = 999999;
	int laserdamage_red_off = 0;
	
	//keyvalues
	int type_to_build = 0;
	string szLaser1 = "";			//
	string szLaser2 = "";			//
	string szCreditsAdd = "";		// Credit adding entity
	string szPrison = "";			// Prison teleport destination

	bool KeyValue( const string& in szKey, const string& in szValue )
	{
	
		if(szKey == "towerid") // 
		{
			tower_ID = atoi( szValue );
			return true;
		}
			
		else if(szKey == "typetobuild") // 
		{
			type_to_build = atoi( szValue );
			return true;
		}
		
		else if(szKey == "laser1") // 
		{
			szLaser1 = szValue;
			return true;
		}
		
		else if(szKey == "laser2") // 
		{
			szLaser2 = szValue;
			return true;
		}
		
		else if(szKey == "creditaddentity") // 
		{
			szCreditsAdd = szValue;
			return true;
		}
		
		else if(szKey == "prison") // 
		{
			szPrison = szValue;
			return true;
		}
		
		else
			return BaseClass.KeyValue( szKey, szValue );
	
	}

	void Use(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue)
	{
		
		g_Game.AlertMessage( at_console, "Barrier" + tower_ID + " triggered. Status:" + tower_type + "Next:" + type_to_build + "\n" );
				
		// 0 - Nothing event
		if(tower_type == 0){ }
		
		// 1 - Turret event
		if(tower_type == 1){ }
		
		// 2 - Blue barrier event
		if(tower_type == 2){ g_EntityFuncs.FireTargets( szCreditsAdd, @self, @self, USE_TOGGLE, flValue ); }
		
		// 3 - Green barrier event
		if(tower_type == 3){ }
		
		// Yellow barrier event
		if(tower_type == 4){ 
		
			if(cooldown <= 0){
			
				Vector prisonOrigin = g_EntityFuncs.FindEntityByTargetname(null, szPrison).pev.origin;
			
				g_EntityFuncs.SetOrigin( pActivator, prisonOrigin );
				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser1).edict(), "renderamt", renderamt_off );
				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser2).edict(), "renderamt", renderamt_off );
				cooldown = cooldown_yellow;
				self.pev.nextthink = g_Engine.time + 1;
			}
			
		}
		
		// Red barrier event
		if(tower_type == 5){ 
		
			if(cooldown <= 0){
			
				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser1).edict(), "renderamt", renderamt_off );
				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser2).edict(), "renderamt", renderamt_off );
				cooldown = cooldown_red;
				self.pev.nextthink = g_Engine.time + 1;
				
			}
		}
		
		
	
	}
	
	void OnCreate()
	{
		g_Game.AlertMessage( at_console, "Barrier created \n" );
		
		szLaser1 = "spot" + tower_ID + "_laser1";
		szLaser2 = "spot" + tower_ID + "_laser2";
		szCreditsAdd = "credits_add_blue";
		
		self.pev.nextthink = g_Engine.time + 2;
		
	}
	
	void Think()
	{
	
		szLaser1 = "spot" + tower_ID + "_laser1";
		szLaser2 = "spot" + tower_ID + "_laser2";
		szCreditsAdd = "credits_add_blue";
		
		if(tower_type != type_to_build){
		
			tower_type = type_to_build;
			cooldown = 0;
			
		}
		
		if(cooldown >= 0){ cooldown -= 1; }
		if(cooldown <= 0){
			
			cooldown = 0;
			
			g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser1).edict(), "renderamt", renderamt_on );
			g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser2).edict(), "renderamt", renderamt_on );
			
			if(tower_type == 5){

				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser1).edict(), "damage", laserdamage_red_on );
				g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser2).edict(), "damage", laserdamage_red_on );

			}
			
		}
		else{
		
			if(tower_type == 5){
			
			g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser1).edict(), "damage", laserdamage_red_off );
			g_EntityFuncs.DispatchKeyValue( g_EntityFuncs.FindEntityByTargetname(null, szLaser2).edict(), "damage", laserdamage_red_off );
			
			}
			
		}
		
		self.pev.nextthink = g_Engine.time + 1;
	
	}

}

